searchData={"items":[{"type":"extras","title":"README","doc":"[![CI](https://github.com/rudebono/absinthe_one_of/actions/workflows/ci.yaml/badge.svg?branch=main)](https://github.com/rudebono/absinthe_one_of/actions/workflows/ci.yaml)\n\n# Absinthe one_of\n\nSupport an Input Union Type System Directive in Absinthe.","ref":"readme.html"},{"type":"extras","title":"Installation - README","doc":"Add `:absinthe_one_of` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps() do\n  [\n    {:absinthe_one_of, \"~> 1.0.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - README","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Step 1: Define Schema - README","doc":"Create a schema module and define your types, including the `@prototype_schema AbsintheOneOf.Directive`:\n\n```elixir\ndefmodule YourWebApp.Schema do\n  use Absinthe.Schema\n\n  @prototype_schema AbsintheOneOf.Directive\n\n  query do\n    ...\n  end\n\n  mutation do\n    ...\n  end\n\n  subscription do\n    ...\n  end\n\n  ...\n\n  input_object(:one_of_input) do\n    directive(:one_of)\n    field(:a, :a_input)\n    field(:b, :b_input)\n  end\n\n  input_object(:a_input) do\n    ...\n  end\n\n  input_object(:b_input) do\n    ...\n  end\nend\n```","ref":"readme.html#step-1-define-schema"},{"type":"extras","title":"Step 2: Setup Absinthe Pipeline - README","doc":"Configure the Absinthe pipeline to include the `absinthe_one_of` phase:\n\n```elixir\ndefmodule YourWebApp.Endpoint do\n  use YourWebApp, :router\n\n  ...\n\n  def pipeline(config, pipeline_opts) do\n    config.schema_mod\n    |> Absinthe.Pipeline.for_document(pipeline_opts)\n    |> Absinthe.Pipeline.insert_after(\n      Absinthe.Phase.Document.Validation.OnlyOneSubscription,\n      AbsintheOneOf.Phase\n    )\n  end\nend\n```","ref":"readme.html#step-2-setup-absinthe-pipeline"},{"type":"extras","title":"Step 3: Testing - README","doc":"To write tests for your implementation, you can refer to the example tests provided in `test/absinthe_one_of_test.exs`. These tests demonstrate how to validate the functionality of the one_of directive and ensure that only one field is non-null among several options.","ref":"readme.html#step-3-testing"},{"type":"extras","title":"Inspiration - README","doc":"This package was inspired by an article written by Maarten Van Vliet.\n\nYou can read the original article [Creating an Input Union Type System Directive in Absinthe](https://maartenvanvliet.nl/2022/04/28/absinthe_input_union/).","ref":"readme.html#inspiration"},{"type":"extras","title":"License - README","doc":"This project is licensed under the MIT License - see the `LICENSE` file for details.","ref":"readme.html#license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}